<template>
  <div>
    <b-table
      :current-page="currentPage"
      :fields="fields"
      :items="gravWaveAlerts"
      :per-page="perPage"
      show-empty
    />
    <b-pagination
      v-if="rows > perPage"
      v-model="currentPage"
      :per-page="perPage"
      :total-rows="rows"
      align="right"
    />
  </div>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import { BvTableFieldArray } from 'bootstrap-vue';
import { GravWaveAlert } from '@/common/types';

const BASE_FIELDS: BvTableFieldArray = [
  {
    key: 'id',
    label: 'Alert ID',
  },
  {
    key: 'mjd',
    label: 'MJD',
    formatter: (value: number) => value.toFixed(2),
  },
  {
    key: 'contour_area',
    label: 'Contour Area (sq. deg.)',
    formatter: Math.round,
  },
  {
    key: 'contour_level',
    formatter: Math.round,
  },
];

export default Vue.extend({
  props: {
    gravWaveAlerts: {
      default: () => [],
      type: Array,
    } as PropOptions<GravWaveAlert[]>,
  },

  data() {
    return {
      currentPage: 1,
      perPage: 10,
    };
  },

  computed: {
    fields(): BvTableFieldArray {
      return BASE_FIELDS;
    },
    rows() {
      return this.gravWaveAlerts.length;
    },
  },
});
</script>
